############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import ZSI as _ZSI
from ZSI.TC import _get_global_element_declaration as _GED
from ZSI.TC import ElementDeclaration as _ElementDeclaration
from ZSI.TC import TypeDefinition as _TypeDefinition

'''
Patches:
Generator problems and bugs in Specifications.
Just need to load this module FIRST in order for the patches to take affect.

'''

class QueryResourcePropertiesResponse_Dec(_ZSI.TCcompound.Struct, _ElementDeclaration):
    '''Path for <any> minOccurs facet... In XML Schema it is required, however, 
    several examples provide for only a boolean result return in the mixed text content.
    Also there is a wsdl2py generator problem w/ComplexContent mixed=True, since
    this is not being generated correctly.
    '''
    schema = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
    literal = "QueryResourcePropertiesResponse"
    def __init__(self, **kw):
        ns = QueryResourcePropertiesResponse_Dec.schema
        TClist = [\
            _ZSI.TC.AnyElement(aname="_any", minOccurs=0, maxOccurs="unbounded", 
                nillable=False),
        ]
        kw["pname"] = ("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","QueryResourcePropertiesResponse")
        kw["aname"] = "_QueryResourcePropertiesResponse"
        class Holder:
            typecode = self
            
        _ZSI.TCcompound.Struct.__init__(self, Holder, TClist, inorder=0, mixed=True, 
            mixed_aname="_text", **kw)


class SetResourceProperties_Dec(_ZSI.TCcompound.Struct, _ElementDeclaration):
    '''Patch for <choice>
    '''
    schema = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
    literal = "SetResourceProperties"
    def __init__(self, **kw):
        ns = SetResourceProperties_Dec.schema
        ens = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
        TClist = [_GED(ens,"Insert")(minOccurs=0, maxOccurs=1, nillable=0), 
            _GED(ens,"Update")(minOccurs=0, maxOccurs=1, nillable=0), 
            _GED(ens,"Delete")(minOccurs=0, maxOccurs=1, nillable=0),
        ]
        kw["pname"] = ("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","SetResourceProperties")
        kw["aname"] = "_SetResourceProperties"
        class Holder:
            typecode = self
            def __init__(self):
                # pyclass
                self._Insert = None
                self._Update = None
                self._Delete = None
                return
        _ZSI.TCcompound.Struct.__init__(self, Holder, TClist, inorder=0, **kw)


class ReferenceParametersType_Def(_ZSI.TC.Struct, _TypeDefinition):
    """BUG This type is not defined in ws-addressing, but it's being used.
    <wsa:ReferenceParameters xsi:type="wsa:ReferenceParametersType"/>
    """
    schema = 'http://schemas.xmlsoap.org/ws/2004/03/addressing'
    type = (schema, "ReferenceParametersType")

    def __init__(self, pname, **kw):
        class Holder:
            typecode = self
        _ZSI.TC.Struct.__init__(self, Holder, [], pname=pname, inorder=0, **kw)


class KeyInfoType_Def(_ZSI.TCcompound.Struct, _TypeDefinition):
    '''Patch for <choice>
    '''
    schema = "http://www.w3.org/2000/09/xmldsig#"
    type = (schema, "KeyInfoType")
    attribute_typecode_dict = {}
    def __init__(self, pname, **kw):
        self._KeyName = None
        self._KeyValue = None
        self._RetrievalMethod = None
        self._X509Data = None
        self._PGPData = None
        self._SPKIData = None
        self._MgmtData = None

        ns = KeyInfoType_Def.schema
        TClist = map(lambda n: _GED(ns,n)(minOccurs=0,maxOccurs=1,nillable=0),
            ("KeyName", "KeyValue", "RetrievalMethod", "X509Data", "PGPData", "SPKIData", "MgmtData")
        )
        TClist.append(_ZSI.TC.AnyElement(aname="_any",minOccurs=0,maxOccurs=1,nillable=0))

        # attribute handling code
        self.mixed = True
        self.attribute_typecode_dict.update(KeyInfoType_Def.attribute_typecode_dict)
        self.attribute_typecode_dict["Id"] = _ZSI.TC.AnyType()

        class Holder:
            typecode = self
            def __init__(self):
                # pyclass
                self._KeyName = None
                self._KeyValue = None
                self._RetrievalMethod = None
                self._X509Data = None
                self._PGPData = None
                self._SPKIData = None
                self._MgmtData = None
                return
        _ZSI.TCcompound.Struct.__init__(self, Holder, TClist, pname=pname, \
            inorder=0, mixed=True, mixed_aname="_text", **kw)
    

